program Demo;

uses
  windows,
  messages,
  enZGLine in 'enZGLine.pas';

var
  mode: TMode = (ResX         : 1280;
                 ResY         : 1024;
                 bpp          : 32;
                 full         : true;
                 Freq         : -1;
                 AntiAliasing : false;
                 Samples      : -1;
                 Anisotropy   : true;
                 v_sync       : false);

  T_Particle: TGLTexture;
  P_Sys: TGLSystem;
  ColStart: TParticleColor = (R: 1.0; G: 0.0; B: 0.0; A: 1.0);
  ColEnd  : TParticleColor = (R: 0.0; G: 0.0; B: 1.0; A: 0.0);
  angleX,
  angleY: single;

procedure Init;
begin
  T_Particle := tex2D.LoadTexture('Data\Particle.bmp',true,true,-1,'*PARTICLE*');
  P_Sys := pts.NewID(ColStart,
                     ColEnd,
                     math3D.NewVector3D(0,0,0),
                     math3D.NewVector3D(0,0,0),
                     math3D.NewVector3D(0,-0.1,0),
                     0.5,3.0,0.2,
                     2000,
                     1000,
                     BLEND_ADD,
                     1000,100,
                     math3D.NewVector3D(1.0,0.0,0.01));
end;

procedure Free;
begin

end;

procedure Render;
begin
  ogl.Clear(true,true);
  ogl.Set3D(0.1,100.0,90,1.33333);
  ogl.Translate(0,0,-5);
  ogl.Rotate(angleX,1,0,0);
  ogl.Rotate(angleY,0,1,0);
  tex2D.FilterGroup(TF_ANISOTROPY);
  tex2D.Enable2D;
  tex2D.Enable(T_Particle);
  pts.RenderID(P_Sys);
  tex2D.Disable;
  tex2D.Disable2D;
  ogl.Swap;
end;

procedure Update;
begin
  if inp.KeyDown(VK_ESCAPE) then eng.Quit;
  pts.UpdateID(P_Sys);
  angleX := angleX + 0.1;
  angleY := angleY - 0.2;
  if inp.MouseLDown then
  begin
    angleX := angleX + inp.MouseDelta.Y;
    angleY := angleY + inp.MouseDelta.X;
  end;
end;

procedure Message(m: UINT; w, l: integer);
begin
  if m = WM_KEYUP then
  begin
    case w of
      VK_SPACE: pts.ResetID(P_Sys);
    end;
  end;
end;

begin
  InitENZGLINE;//(mode);

  eng.SetProc(PROC_INIT,@init);
  eng.SetProc(PROC_FREE,@free);
  eng.SetProc(PROC_RENDER,@render);
  eng.SetProc(PROC_UPDATE,@update);
  eng.SetProc(PROC_MSG,@Message);

  txc.Correction(TXC_NONE);  
  eng.Loop(50);
end.
