unit enZGLine;

interface

uses
  windows;

const
  PROC_INIT   = $00;
  PROC_FREE   = $01;
  PROC_UPDATE = $02;
  PROC_RENDER = $03;
  PROC_MSG    = $04;

  FS_NEWFILE   = $00;
  FS_OPENFILE  = $01;

  FROM_BEGIN    = FILE_BEGIN;
  FROM_CURRENT  = FILE_CURRENT;
  FROM_END      = FILE_END;

  BLEND_NONE = $00;
  BLEND_SUB  = $01;
  BLEND_ADD  = $02;
  BLEND_MUL  = $03;

  TF_NONE       = $00;
  TF_BILINEAR   = $01;
  TF_TRILINEAR  = $02;
  TF_ANISOTROPY = $03;

  ENV_MODULATE = $2100;
  ENV_DECAL    = $2101;
  ENV_BLEND    = $0BE2;
  ENV_REPLACE  = $1E01;

  POINT           = 0;
  LINE            = 1;
  LINE_LOOP       = 2;
  LINE_STRIP      = 3;
  TRIANGLES       = 4;
  TRIANGLES_STRIP = 5;
  TRIANGLES_FAN   = 6;
  QUADS           = 7;
  QUADS_STRIP     = 8;
  POLYGON         = 9;

  FOG_LINEAR      = 0;
  FOG_EXP         = 1;
  FOG_EXP2        = 2;

  BUF_DATA        = 0;
  BUF_ELEMENT     = 1;

  ARR_VERTEX      = 0;
  ARR_NORMAL      = 1;
  ARR_TEXCOORD    = 2;
  ARR_COLOR       = 3;

  FACE_FRONT      = 0;
  FACE_BACK       = 1;
  FACE_NONE       = 2;

  POLY_WIRE       = 0;
  POLY_FILL       = 1;    

  GLSL_VERTEX   = 0;
  GLSL_FRAGMENT = 1;

  AL_LISTENER_NAME = 'LISTENER';

  TEXENV_COMBINE_ARB        = $8570;
  TEXENV_COMBINE_RGB_ARB    = $8571;
  TEXENV_COMBINE_ALPHA_ARB  = $8572;
  TEXENV_SOURCE0_RGB_ARB    = $8580;
  TEXENV_SOURCE1_RGB_ARB    = $8581;
  TEXENV_SOURCE2_RGB_ARB    = $8582;
  TEXENV_SOURCE0_ALPHA_ARB  = $8588;
  TEXENV_SOURCE1_ALPHA_ARB  = $8589;
  TEXENV_SOURCE2_ALPHA_ARB  = $858A;
  TEXENV_OPERAND0_RGB_ARB   = $8590;
  TEXENV_OPERAND1_RGB_ARB   = $8591;
  TEXENV_OPERAND2_RGB_ARB   = $8592;
  TEXENV_OPERAND0_ALPHA_ARB = $8598;
  TEXENV_OPERAND1_ALPHA_ARB = $8599;
  TEXENV_OPERAND2_ALPHA_ARB = $859A;
  TEXENV_RGB_SCALE_ARB      = $8573;
  TEXENV_ADD_SIGNED_ARB     = $8574;
  TEXENV_INTERPOLATE_ARB    = $8575;
  TEXENV_SUBTRACT_ARB       = $84E7;
  TEXENV_CONSTANT_ARB       = $8576;
  TEXENV_PRIMARY_COLOR_ARB  = $8577;
  TEXENV_PREVIOUS_ARB       = $8578;
  TEXENV_TEXTURE_ENV_MODE   = $2200;
  TEXENV_SRC_COLOR          = $0300;
  TEXENV_ONE                = 1;
  TEXENV_ZERO               = 1;
  TEXENV_ONE_MINUS_SRC_COLOR= $0301;
  TEXENV_SRC_ALPHA          = $0302;
  TEXENV_ONE_MINUS_SRC_ALPHA= $0303;
  TEXENV_DST_ALPHA          = $0304;
  TEXENV_ONE_MINUS_DST_ALPHA= $0305;
  TEXENV_TEXTURE            = $1702;
  TEXENV_REPLACE            = ENV_REPLACE;

  GL_BGR_EXT                        = $80E0;
  GL_BGRA_EXT                       = $80E1;
  GL_COLOR_INDEX                    = $1900;
  GL_STENCIL_INDEX                  = $1901;
  GL_DEPTH_COMPONENT                = $1902;
  GL_RED                            = $1903;
  GL_GREEN                          = $1904;
  GL_BLUE                           = $1905;
  GL_ALPHA                          = $1906;
  GL_RGB                            = $1907;
  GL_RGBA                           = $1908;
  GL_LUMINANCE                      = $1909;
  GL_LUMINANCE_ALPHA                = $190A;
  GL_ALPHA4                         = $803B;
  GL_ALPHA8                         = $803C;
  GL_ALPHA12                        = $803D;
  GL_ALPHA16                        = $803E;
  GL_LUMINANCE4                     = $803F;
  GL_LUMINANCE8                     = $8040;
  GL_LUMINANCE12                    = $8041;
  GL_LUMINANCE16                    = $8042;
  GL_LUMINANCE4_ALPHA4              = $8043;
  GL_LUMINANCE6_ALPHA2              = $8044;
  GL_LUMINANCE8_ALPHA8              = $8045;
  GL_LUMINANCE12_ALPHA4             = $8046;
  GL_LUMINANCE12_ALPHA12            = $8047;
  GL_LUMINANCE16_ALPHA16            = $8048;
  GL_INTENSITY                      = $8049;
  GL_INTENSITY4                     = $804A;
  GL_INTENSITY8                     = $804B;
  GL_INTENSITY12                    = $804C;
  GL_INTENSITY16                    = $804D;
  GL_R3_G3_B2                       = $2A10;
  GL_RGB4                           = $804F;
  GL_RGB5                           = $8050;
  GL_RGB8                           = $8051;
  GL_RGB10                          = $8052;
  GL_RGB12                          = $8053;
  GL_RGB16                          = $8054;
  GL_RGBA2                          = $8055;
  GL_RGBA4                          = $8056;
  GL_RGB5_A1                        = $8057;
  GL_RGBA8                          = $8058;
  GL_RGB10_A2                       = $8059;
  GL_RGBA12                         = $805A;
  GL_RGBA16                         = $805B;
  GL_TEXTURE_RED_SIZE               = $805C;
  GL_TEXTURE_GREEN_SIZE             = $805D;
  GL_TEXTURE_BLUE_SIZE              = $805E;
  GL_TEXTURE_ALPHA_SIZE             = $805F;
  GL_TEXTURE_LUMINANCE_SIZE         = $8060;
  GL_TEXTURE_INTENSITY_SIZE         = $8061;
  GL_PROXY_TEXTURE_1D               = $8063;
  GL_PROXY_TEXTURE_2D               = $8064;  

  TXC_WORST  = 0;
  TXC_NONE   = 1;
  TXC_BEST   = 2;

  PTS_STARTCOLOR   = $00;
  PTS_ENDCOLOR     = $01;
  PTS_POSITION     = $02;
  PTS_POSDIV       = $03;
  PTS_VELOCITY     = $04;
  PTS_VELDIV       = $05;
  PTS_ACCELERATION = $06;
  PTS_ACCELDIV     = $07;
  PTS_ALIVETIME    = $08;
  PTS_ALIVEDIV     = $09;
  PTS_BLENDTYPE    = $0A;
  PTS_MAXPARTICLES = $0B;
  PTS_SIZE         = $0C;
  PTS_QUADR        = $0D;
  PTS_REUPDATE     = $0E;

type
  TVector2D = record
  case integer of
    0: (x, y: single);
    1: (u, v: single);
    2: (s, t: single);
    3: (vec: array[0..1] of single);
  end;

  TVector3D = record
  case integer of
    0: (x, y, z: single);
    1: (u, v, f: single);
    2: (vec: array[0..2] of single);
  end;

  TPlane = record
  case integer of
    0: (x, y, z, dst: single);
    1: (normal: TVector3D; distance: single);
    2: (plane: array[0..3] of single);
  end;

  TMatrix4x4 = record
  case integer of
    0: (_11, _12, _13, _14,
        _21, _22, _23, _24,
        _31, _32, _33, _34,
        _41, _42, _43, _44: single);
    1: (m: array[0..3,0..3] of single);
  end;

  TQuaternion = record
  case integer of
    0: (x, y, z, w: single);
    1: (q: array[0..3] of single);
  end;

  TQuad = record
  case integer of
    0: (min, max: TVector2D);
    1: (x1, y1, x2, y2: single);
  end;

  TBox = record
  case integer of
    0: (min, max: TVector3D);
    1: (x1, y1, z1, x2, y2, z2: single);
  end;

  TMode = record
    ResX, ResY    : integer;
    bpp           : byte;
    full          : boolean;
    Freq          : integer;
    AntiAliasing  : boolean;
    Samples       : integer;
    Anisotropy    : boolean;
    v_sync        : boolean;
  end;

  TParticleColor = record
    R, G, B, A: single;
  end;

  TGLFont      = DWORD;
  TGLTexture   = DWORD;
  TGLModel     = DWORD;
  TGLBuffer    = DWORD;
  TGLFBuffer   = DWORD;
  TGLRBuffer   = DWORD;    
  TGLSLShader  = DWORD;
  TGLSLProgram = DWORD;
  TALBuffer    = DWORD;
  TALSource    = DWORD;
  TGLOccObj    = DWORD;
  TGLSystem    = DWORD;

  ILog = interface
  ['{FCD3069F-8EE8-497C-87B7-7FCDCFF9B48F}']
    procedure print(message: string);                             overload;
    procedure print(ID: string; message: string);                 overload;
    procedure print(ID: string; message: string; status: string); overload;
    procedure msg(message: string);
    procedure EnableTiming;
    procedure DisableTiming;
  end;

  IWindow = interface
  ['{B2083E13-36AC-4BA8-9C40-86E76FD78CB8}']
    procedure Mode;
    procedure ReturnDefaultMode;
    function GetMode: TMode;
    procedure SetMode(mode: TMode);
  end;

  IInput = interface
  ['{C0879604-FD97-400B-8931-AFFB2ED79F4E}']
    procedure Reset;
    procedure LockMouse;
    procedure FreeMouse;
    procedure CursorShow;
    procedure CursorHide;
    function KeyDown(Key: byte): boolean;
    function MousePos: TPoint;
    function MouseDelta: TPoint;
    function MouseLDown: boolean;
    function MouseRDown: boolean;
    function MouseMDown: boolean;
    function MouseLocked: boolean;
  end;

  ICustomStream = interface
  ['{9A5F53EF-6BBD-4A17-AC68-6C69FA07C9AF}']
    function Read(var buf; size: DWORD): DWORD;
    function Write(var buf; size: DWORD): DWORD;               
    function Seek(offset: integer; method: DWORD): DWORD;      
    function Size: DWORD;                                      
    function Pos: DWORD;                                       
    function name: string;                                      overload;
    procedure name(NewID: string);                              overload;
    function CopyFrom(src: ICustomStream; size: DWORD): DWORD;
    function Valid: boolean;
    procedure SaveToFile(filename: string);    
  end;

  IFileStream = interface(ICustomStream)
  ['{3B2854F3-18C2-4DF8-B80A-9293546BC7B1}']
    function Read(var buf; size: DWORD): DWORD;
    function Write(var buf; size: DWORD): DWORD;
    function Seek(offset: integer; method: DWORD): DWORD;
    function Size: DWORD;
    function Pos: DWORD;
    function CopyFrom(src: ICustomStream; size: DWORD): DWORD;
    function Valid: boolean;
    function name: string;                                     overload;
    procedure name(NewID: string);                             overload;
  end;

  IMemoryStream = interface(ICustomStream)
  ['{72058A2E-E7A9-47D6-8CEA-D2E802A81AE7}']
    function Read(var buf; size: DWORD): DWORD;
    function Write(var buf; size: DWORD): DWORD;
    function Seek(offset: integer; method: DWORD): DWORD;
    function Size: DWORD;
    function Pos: DWORD;
    function CopyFrom(src: ICustomStream; size: DWORD): DWORD;
    function Valid: boolean;
    function name: string;                                     overload;
    procedure name(NewID: string);                             overload;    
  end;

  IFileSystem = interface
  ['{715A492E-74D3-4BC0-AC32-3AF801565F11}']
    procedure AddPacksDir(dir: string);
    procedure Dispose;
    function OpenFile(name: string): ICustomStream;
  end;

  IOpenGL = interface
  ['{632397D7-3703-4BF3-A5DE-1FC31AB1D79A}']
    procedure Clear(color, depth: boolean);
    procedure Swap;

    procedure Set2D; overload;
    procedure Set2D(width, height: integer); overload;
    procedure Set3D(Pnear, Pfar, FOVY, Aspect: single);
    procedure SetView(x, y, w, h: integer);    

    function FontCreate(fontname: PAnsiChar; w, h: integer): TGLFont;
    procedure glTextOut(text: string; X, Y: single; fontID: TGLFont);
    procedure FontDelete(font: TGLFont);
    function DebugFont: TGLFont;

    procedure SetColor(r, g, b: single); overload;
    procedure SetColor(r, g, b, a: single); overload;
    procedure SetVertex(x, y: single); overload;
    procedure SetVertex(x, y, z: single); overload;
    procedure SetTxCoord(u, v: single); overload;
    procedure SetTxCoord(u, v: single; tex_index: byte); overload;
    procedure SetTxCoord(u: single); overload;
    procedure SetTxCoord(u: single; tex_index: byte); overload;
    procedure SetTxCoord(u, v, f: single); overload;
    procedure SetTxCoord(u, v, f: single; tex_index: byte); overload;
    procedure SetNormal(x, y, z: single);
    procedure EnablePolygon(polygon_type: WORD);
    procedure DisablePolygon;

    procedure VertexPointer(vertex_size: integer; data: pointer);
    procedure ColorPointer(color_size: integer; data: pointer);
    procedure TexCoordPointer(texcoord_size: integer; data: pointer; tex_index: byte = 0);
    procedure NormalPointer(data: pointer);
    procedure DrawArray(polygon_type: WORD; count: integer);
    procedure DisableArray;

    procedure Enable(target: DWORD);
    procedure Disable(target: DWORD);
    procedure AntiAliasing(switch_on: boolean);

    procedure Blend(blend_type: byte);

    procedure Rotate(angle, rX, rY, rZ: single);
    procedure Translate(tx, ty, tz: single);
    procedure Scale(sx, sy, sz: single);
    procedure Look(fromX, fromY, fromZ, toX, toY, toZ, upX, upY, upZ: single);
    function GetModelViewMatrix: TMatrix4x4;
    function GetProjectionMatrix: TMatrix4x4;
    function GetTexMatrix: TMatrix4x4;
    procedure SetModelViewMatrix(m: TMatrix4x4);
    procedure SetProjectionMatrix(m: TMatrix4x4);
    procedure SetTexMatrix(m: TMatrix4x4);

    procedure ClearColor(r, g, b, a: single);
    procedure EnableFog(r, g, b, a, density, _start, _end: single; mode: byte);
    procedure DisableFog;

    procedure CullFacing(face: byte);
    procedure RenderMode(mode: byte);

    procedure EnableClipPlane(ClipPlane: Byte; p: TPlane);
    procedure DisableClipPlane(ClipPlane: Byte);

    procedure EnableLight;
    procedure DisableLight;

    function extBGR          : boolean;
    function extAntiAliasing : boolean;
    function extMultitexture : boolean;
    function extAnisotropy   : boolean;
    function extVBO          : boolean;
    function extGLSL         : boolean;
    function extVSYNC        : boolean;
    function extOcclusion    : boolean;
    function extTexCombine   : boolean;
    function extTex3D        : boolean;
    function extTexPack      : boolean;
    function extTexQube      : boolean;
    function extFBO          : boolean;
    function extPSys         : boolean;        
  end;

  ITexture1D = interface
  ['{9076868D-A0E2-4127-9FEE-2A835CB4B0D1}']
    function NewID(data: pointer; width: integer; f: WORD; mipmap, clamp: boolean; name: string; group: integer = -1): TGLTexture;
    function GetID(name: string): TGLTexture;
    procedure ClearCash;

    function LoadTexture(filename: string; mipmap: boolean; clamp: boolean; group: integer = -1; name: string = ''): TGLTexture;
    procedure FreeTexture(ID: TGLTexture);

    procedure Enable(ID: TGLTexture); overload;
    procedure Enable(ID: TGLTexture; tunit: byte; env_mode: WORD); overload;
    procedure Enable(ID: TGLTexture; tunit: byte); overload;
    procedure Disable;                 overload;
    procedure Disable(tunit: integer); overload;

    procedure FilterGroup(ftype: byte; group: integer = -1);
    procedure FilterTex(ftype: byte; ID: TGLTexture);
    procedure DeleteGroup(group: integer);

    procedure EnableSphereTexCoords;
    procedure DisableSphereTexCoords;

    procedure Enable1D;
    procedure Disable1D;

    procedure EnvSetup(Arg, Func: DWORD);
  end;

  ITexture2D = interface
  ['{3ECC9C30-03C2-4EFD-B3AE-CAC29B26DB7C}']
    function NewID(data: pointer; width, height: integer; f: WORD; mipmap, clamp: boolean; name: string; group: integer = -1): TGLTexture;
    function GetID(name: string): TGLTexture;
    procedure ClearCash;

    function LoadTexture(filename: string; mipmap: boolean; clamp: boolean; group: integer = -1; name: string = ''): TGLTexture;
    procedure FreeTexture(ID: TGLTexture);

    procedure Enable(ID: TGLTexture); overload;
    procedure Enable(ID: TGLTexture; tunit: byte; env_mode: WORD); overload;
    procedure Enable(ID: TGLTexture; tunit: byte); overload;
    procedure Disable;                 overload;
    procedure Disable(tunit: integer); overload;

    procedure FilterGroup(ftype: byte; group: integer = -1);
    procedure FilterTex(ftype: byte; ID: TGLTexture);
    procedure DeleteGroup(group: integer);

    procedure EnableSphereTexCoords;
    procedure DisableSphereTexCoords;
    procedure ScreenShot(filename: string);

    procedure Enable2D;
    procedure Disable2D;

    procedure EnvSetup(Arg, Func: DWORD);
  end;

  ITexture3D = interface
  ['{33AEB29A-E6E2-43A8-995F-8A4200A73DC8}']
    function NewID(data: pointer; width, height, depth: integer; f: WORD; mipmap, clamp: boolean; name: string; group: integer = -1): TGLTexture;
    function GetID(name: string): TGLTexture;
    procedure ClearCash;

    function LoadTexture(filename: string; mipmap: boolean; clamp: boolean; group: integer = -1; name: string = ''): TGLTexture;
    procedure FreeTexture(ID: TGLTexture);

    procedure Enable(ID: TGLTexture); overload;
    procedure Enable(ID: TGLTexture; tunit: byte; env_mode: WORD); overload;
    procedure Enable(ID: TGLTexture; tunit: byte); overload;
    procedure Disable;                 overload;
    procedure Disable(tunit: integer); overload;

    procedure DeleteGroup(group: integer);

    procedure EnableSphereTexCoords;
    procedure DisableSphereTexCoords;

    procedure Enable3D;
    procedure Disable3D;

    procedure EnvSetup(Arg, Func: DWORD);
  end;

  ITextureCompressed = interface
  ['{7D41D1CD-37F9-4AEE-B86F-90A6173C5E85}']
    function LoadTexture1D(FileName: string; mipmap: boolean; clamp: boolean; group: integer = -1; name: string = ''): TGLTexture;
    function LoadTexture2D(FileName: string; mipmap: boolean; clamp: boolean; group: integer = -1; name: string = ''): TGLTexture;
    function LoadTexture3D(FileName: string; mipmap: boolean; clamp: boolean; group: integer = -1; name: string = ''): TGLTexture;

    procedure Correction(hint: byte);
  end;

  ITextureQube = interface
  ['{F6E618CD-A2B0-468C-934F-7FA4E00EACAC}']
    function NewIDQ(data: array of pointer; width, height: integer; f: WORD; mipmap, clamp: boolean; name: string; group: integer): TGLTexture;
    function LoadTexture(filenames: array of string; mipmap: boolean; clamp: boolean; group: integer = -1; name: string = ''): TGLTexture;
    function GetID(name: string): TGLTexture;
    function GetIDxp(name: string): TGLTexture; overload;
    function GetIDxn(name: string): TGLTexture; overload;
    function GetIDyp(name: string): TGLTexture; overload;
    function GetIDyn(name: string): TGLTexture; overload;
    function GetIDzp(name: string): TGLTexture; overload;
    function GetIDzn(name: string): TGLTexture; overload;

    function GetIDxp(ID     : TGLTexture): TGLTexture; overload;
    function GetIDxn(ID     : TGLTexture): TGLTexture; overload;
    function GetIDyp(ID     : TGLTexture): TGLTexture; overload;
    function GetIDyn(ID     : TGLTexture): TGLTexture; overload;
    function GetIDzp(ID     : TGLTexture): TGLTexture; overload;
    function GetIDzn(ID     : TGLTexture): TGLTexture; overload;

    procedure FreeID(ID: TGLTexture);
    procedure DeleteGroup(group: integer = -1);

    procedure EnableQ;
    procedure DisableQ;

    procedure Enable(ID: TGLTexture);                              overload;
    procedure Enable(ID: TGLTexture; tunit: byte);                 overload;
    procedure Enable(ID: TGLTexture; tunit: byte; env_mode: WORD); overload;
    procedure Disable;              overload;
    procedure Disable(tunit: WORD); overload;

    procedure AutoCoords(refl: boolean);
    procedure DisableAutoCoords;

    procedure FilterGroup(ftype: byte; group: integer = -1);
    procedure FilterTex(ftype: byte; ID: TGLTexture);  
  end;  

  IModel = interface
  ['{0985B5CB-F4C5-43A6-830A-4DEDBFDF73FF}']
    function NewID(V_Count, F_Count, T_Count, Frames: integer; data: pointer; indexes: pointer; group: integer = -1; AA: boolean = false; name: string = ''; center: pointer = nil): TGLModel;
    function GetID(name: string): TGLModel;

    function LoadModel(filename: string; group: integer = -1; AA: boolean = false; name: string = ''): TGLModel;
    procedure FreeModel(var ID: TGLModel);

    procedure GroupAA(value: boolean; group: integer = -1);
    procedure ModelAA(ID: TGLModel; value: boolean);
    procedure DeleteGroup(group: integer = -1);

    procedure Render(ID: TGLModel; frame: integer);
  end;

  IVertexBufferObject = interface
  ['{47E97486-3D1B-46C8-8D12-A9823EFEE11F}']
    function NewID(data_size: integer; buf_type: byte;                name: string = ''): TGLBuffer; overload;
    function NewID(data_size: integer; buf_type: byte; data: pointer; name: string = ''): TGLBuffer; overload;
    function GetID(name: string): TGLBuffer;
    procedure FreeID(ID: TGLBuffer);
    procedure SubData(buf: TGLBuffer; buf_type: byte; offset, size: integer; data: pointer);

    procedure Enable(V_Buf, I_Buf: TGLBuffer);
    procedure IEnable(I_Buf: TGLBuffer);
    procedure VEnable(V_Buf: TGLBuffer);
    procedure Disable;
    procedure IDisable;
    procedure VDisable;

    procedure VertexPointer(stride: integer; start_pos: integer; elements_count: integer);
    procedure ColorPointer(stride: integer; start_pos: integer; elements_count: integer);
    procedure TexCoordPointer(stride: integer; start_pos: integer; elements_count: integer; tex_index: byte = 0);
    procedure NormalPointer(stride, start_pos: integer);
    procedure DisableArray(array_type: byte);
    procedure EnableArray(array_type: byte);
    procedure RenderBuffer(Primitiv_Type: DWORD; Indexes_count: integer; offset: integer);            overload;
    procedure RenderBuffer(Primitiv_type: DWORD; Indexes_count: integer; offset: integer; bpi: byte); overload;
    procedure RenderVBuffer(Primitiv_type: DWORD; first, count: integer);
  end;


  IFrameBufferObject = interface
  ['{14F035A9-699D-44E8-B6B9-523F92774BA8}']
    function NewID(Width, Height: Integer; name: String; Group: Integer; depth: boolean): TGLFBuffer;
    function GetID(Name: String): TGLFBuffer;
    procedure FreeID(ID: TGLFBuffer);
    procedure FreeGroup(Group: Integer);
    procedure Enable(ID: TGLFBuffer; TexColor: TGLTexture; TexDepth: TGLTexture);
    procedure Disable;
  end;

  IVertexFragmentProgram = interface
  ['{0812E8A8-2827-4526-AAFB-CA47EA5ACE69}']
    function NewID(name: string): TGLSLShader;
    function GetID(name: string): TGLSLShader;
    procedure FreeID(ID: TGLSLProgram);
    function CompileShader(filename: string; vfptype: byte): TGLSLShader;
    procedure AttachShaders(prog: TGLSLProgram; vsh, fsh: TGLSLShader);

    function LoadProgram(names: string; name: string = ''): TGLSLProgram;                overload;
    function LoadProgram(vsh, fsh: string; name: string = ''): TGLSLProgram;             overload;

    function GetUniformLocation(prog: TGLSLProgram; name: PAnsiChar): Integer;
    function GetAttribLocation(prog: TGLSLProgram; name: PAnsiChar): Integer;

    procedure SetUniform1f(prog: TGLSLProgram; name: PAnsiChar; v0: single);             overload;
    procedure SetUniform2f(prog: TGLSLProgram; name: PAnsiChar; v0, v1: single);         overload;
    procedure SetUniform3f(prog: TGLSLProgram; name: PAnsiChar; v0, v1, v2: single);     overload;
    procedure SetUniform4f(prog: TGLSLProgram; name: PAnsiChar; v0, v1, v2, v3: single); overload;
    procedure SetUniform1i(prog: TGLSLProgram; name: PAnsiChar; i0: Integer);            overload;

    procedure SetUniform1f(prog: TGLSLProgram; loc: Integer; v0: single);                overload;
    procedure SetUniform2f(prog: TGLSLProgram; loc: Integer; v0, v1: single);            overload;
    procedure SetUniform3f(prog: TGLSLProgram; loc: Integer; v0, v1, v2: single);        overload;
    procedure SetUniform4f(prog: TGLSLProgram; loc: Integer; v0, v1, v2, v3: single);    overload;
    procedure SetUniform1i(prog: TGLSLProgram; loc: Integer; i0: Integer);               overload;

    procedure SetAttrib1f(prog: TGLSLProgram; name: PAnsiChar; v0: single);              overload;
    procedure SetAttrib2f(prog: TGLSLProgram; name: PAnsiChar; v0, v1: single);          overload;
    procedure SetAttrib3f(prog: TGLSLProgram; name: PAnsiChar; v0, v1, v2: single);      overload;

    procedure SetAttrib1f(prog: TGLSLProgram; loc: Integer; v0: single);                 overload;
    procedure SetAttrib2f(prog: TGLSLProgram; loc: Integer; v0, v1: single);             overload;
    procedure SetAttrib3f(prog: TGLSLProgram; loc: Integer; v0, v1, v2: single);         overload;

    procedure Enable(prog: TGLSLProgram);
    procedure Disable;
  end;

  IOpenAL = interface
  ['{0EE5AA96-6FE3-41DA-90EF-3B846EDB76F7}']
    procedure PlayMusic(filename: PAnsiChar; Loop: Boolean);
    procedure StopMusic;

    procedure Play(source: TALSource);
    procedure Stop(source: TALSource);
    procedure Pause(source: TALSource);

    procedure PlayGroup(group: integer = -1);
    procedure StopGroup(group: integer = -1);
    procedure PauseGroup(group: integer = -1);
    procedure GainGroup(gain: single; group: integer = -1);

    function NewSource(pos: TVector3D; vel: TVector3D; gain: Single; name: string; group: Integer = -1): TALSource;
    function GetSource(name: string): TALSource;
    function NewBuffer(name: String; group: Integer): TALBuffer;
    function GetBuffer(name: string): TALBuffer;

    procedure DeleteBuffer(ID: TALBuffer);
    procedure DeleteSource(ID: TALSource);

    function LoadFile(filename: String; group: Integer = -1; name: string = ''): TALBuffer;

    procedure AssignSource(source: TALSource; buffer: TALBuffer);

    procedure SetSourcePos(source: TALSource; pos: TVector3D);
    procedure SetSourceVel(source: TALSource; vel: TVector3D);
    procedure SetSourceLoop(source: TALSource; loop: boolean);
    procedure SetSourceGain(source: TALSource; gain: Single);

    procedure SetListenerPos(pos: TVector3D);
    procedure SetListenerVel(vel: TVector3D);
    procedure SetListenerOri(_to, _up: TVector3D);
    procedure SetListenerGain(gain: Single);
  end;

  IParticleSystem = interface
  ['{A7427CF0-B08C-4FF2-91E1-833C62FB0288}']
    function NewID(ColorStart,
                   ColorEnd: TParticleColor;
                   Pos, V, Accel: TVector3D;
                   DP, DV, DA: single;
                   AliveTime,
                   AliveDiv: Integer;
                   Blend: byte;
                   MaxParticles: Integer; Size: single; quadr: TVector3D;
                   reupdate: boolean;
                   name: string =''; Group: Integer = -1): TGLSystem;
    function GetID(name: String): TGLSystem;
    procedure FreeID(ID: TGLSystem);
    procedure FreeGroup(group: Integer);

    procedure RenderID(ID: TGLSystem);
    procedure UpdateID(ID: TGLSystem);
    procedure ResetID(ID: TGLSystem);

    procedure RenderGroup(Group: Integer);
    procedure UpdateGroup(Group: Integer);
    procedure ResetGroup(Group: Integer);

    procedure SetParameter(ID: TGLSystem; ParamType: byte; Parameter: pointer);    
  end;

  IOcclusion = interface
  ['{C9269547-3940-4A69-B35F-D9E99A530EAC}']
    function NewID(box: TBox; group: integer = -1): TGLOccObj;
    procedure SetBox(ID: TGLOccObj; Box: TBox);
    function GetBox(ID: TGLOccObj): TBox;
    procedure FreeID(ID: TGLOccObj);

    procedure DeleteGroup(group: integer = -1);

    procedure Enable;
    procedure Disable;
    procedure PostQuery(ID: TGLOccObj);
    procedure PostQueryGroup(group: integer = -1);
    procedure PostQueryArray(IDs: array of TGLOccObj);

    function IsQueryReady(ID: TGLOccObj): boolean;
    function GetQueryResult(ID: TGLOccObj): DWORD;
  end;

  ICamera = interface
  ['{D9CC8D9A-C97E-46E1-9297-37BFC3576A0E}']
    procedure Init(p, a: TVector3D);
    procedure SetProj(FOV, aspect, P_near, P_far: single);
    procedure Update;

    procedure Step(v: TVector3D);
    procedure Move(p: TVector3D);
    procedure Rot(r: TVector3D);
    procedure Ang(a: TVector3D);
    function GetAngle: TVector3D;
    function GetPos: TVector3D;

    procedure StepForward(s: single);
    procedure StepBackward(s: single);
    procedure StepLeft(s: single);
    procedure StepRight(s: single);  
  end;

  IMath = interface
  ['{E6B0DBCF-CF77-4589-9E39-5476A390E815}']
    function NewVector2D(x, y: single): TVector2D;
    function NewVector3D(x, y, z: single): TVector3D;
    function NewPlane(normal: TVector3D; distance: single): TPlane;  overload;
    function NewPlane(nx, ny, nz, distance: single): TPlane;         overload;
    function NewQuaternion(x, y, z, w: single): TQuaternion;         overload;
    function NewQuaternion(v: TVector3D; angle: single): TQuaternion;overload;
    function NewQuad(min, max: TVector2D): TQuad;                    overload;
    function NewQuad(x1, y1, x2, y2: single): TQuad;                 overload;
    function NewBox(min, max: TVector3D): TBox;                      overload;
    function NewBox(x1, y1, z1, x2, y2, z2: single): TBox;           overload;

    function V_Abs(v: TVector2D): single;                   overload;
    function V_Abs(v: TVector3D): single;                   overload;
    function V_Dot(v1, v2: TVector2D): single;              overload;
    function V_Dot(v1, v2: TVector3D): single;              overload;
    function V_Add(v1, v2: TVector2D): TVector2D;           overload;
    function V_Add(v1, v2: TVector3D): TVector3D;           overload;
    function V_Sub(v1, v2: TVector2D): TVector2D;           overload;
    function V_Sub(v1, v2: TVector3D): TVector3D;           overload;
    function V_Mul(v: TVector2D; f: single): TVector2D;     overload;
    function V_Mul(v: TVector3D; f: single): TVector3D;     overload;
    function V_Mul(v1, v2: TVector3D): TVector3D;           overload;
    function V_Mul(v: TVector3D; m: TMatrix4x4): TVector3D; overload;
    function V_Distance(v1, v2: TVector2D): single;         overload;
    function V_Distance(v1, v2: TVector3D): single;         overload;
    function V_Normalize(v: TVector2D): TVector2D;          overload;
    function V_Normalize(v: TVector3D): TVector3D;          overload;

    function P_Normalize(p: TPlane): TPlane;

    function M_Mul(m1, m2: TMatrix4x4): TMatrix4x4;       overload;
    function M_Mul(m: TMatrix4x4; f: single): TMatrix4x4; overload;
    function M_RotX(angle: single): TMatrix4x4;
    function M_RotY(angle: single): TMatrix4x4;
    function M_RotZ(angle: single): TMatrix4x4;
    function M_Transl(translation: TVector3D): TMatrix4x4;
    function M_Scale(scale: TVector3D): TMatrix4x4;

    function B_Add(b: TBox; v: TVector3D): TBox;
    function B_Sub(b: TBox; v: TVector3D): TBox;

    function Q_Add(b: TBox; v: TVector3D): TBox; overload;
    function Q_Sub(b: TBox; v: TVector3D): TBox; overload;

    function Qt_GetMatrix(q: TQuaternion): TMatrix4x4;
    function Qt_RotateVector(v: TVector3D; q: TQuaternion): TVector3D;

    procedure BuildFrustum; overload;
    procedure BuildFrustum(proj, view: TMatrix4x4); overload;
    procedure BuildFrustum(proj_view: TMatrix4x4);  overload;
    function F_BoxInFrust(box: TBox): boolean;
  end;

  IEngine = interface
  ['{F9E31496-B3DD-449E-B0F7-EEF7B1C5505F}']
    procedure SetProc(ID: byte; proc: pointer);
    function GetLog: ILog;
    function GetWnd: IWindow;
    function GetInp: IInput;
    function GetFSys: IFileSystem;
    function GetOGL: IOpenGL;
    function GetTex: ITexture2D;
    function GetTex1D: ITexture1D;
    function GetTex3D: ITexture3D;
    function GetTXPak: ITextureCompressed;
    function GetTXQ: ITextureQube;
    function GetMdl: IModel;
    function GetVBO: IVertexBufferObject;
    function GetFBO: IFrameBufferObject;
    function GetVFP: IVertexFragmentProgram;
    function GetPSys: IParticleSystem;
    function GetOCC: IOcclusion;
    function GetOAL: IOpenAL;
    function GetCam: ICamera;
    function GetMath: IMath;
    function FPS: integer;
    procedure Loop(UPS: integer);
    procedure Quit;
    function GetNameVersion: PChar;
  end;

function enZGLineInit: IEngine; external 'enZGLine.dll';
function enZGLineInit_mode(mode: TMode): IEngine; external 'enZGLine.dll';
function CreateFileStream(filename: string; openflag: byte): IFileStream; external 'enZGLine.dll';
function CreateMemoryStream: IMemoryStream; external 'enZGLine.dll';
procedure DeleteFileStream  (stream: IFileStream); external 'enZGLine.dll';
procedure DeleteMemoryStream(stream: IMemoryStream); external 'enZGLine.dll';

var
  eng  : IEngine                = nil;
  log  : ILog                   = nil;
  wnd  : IWindow                = nil;
  fsys : IFileSystem            = nil;
  inp  : IInput                 = nil;
  ogl  : IOpenGL                = nil;
  tex1D: ITexture1D             = nil;
  tex2D: ITexture2D             = nil;
  tex3D: ITexture3D             = nil;
  txc  : ITextureCompressed     = nil;
  txq  : ITextureQube           = nil;
  mdl  : IModel                 = nil;
  vbo  : IVertexBufferObject    = nil;
  fbo  : IFrameBufferObject     = nil;
  pts  : IParticleSystem        = nil;
  vfp  : IVertexFragmentProgram = nil;
  occ  : IOcclusion             = nil;
  cam  : ICamera                = nil;
  oal  : IOpenAL                = nil;
  math3D: IMath                 = nil;

procedure InitENZGLINE; overload;
procedure InitENZGLINE(mode: TMode); overload;

implementation

procedure InitENZGLINE(mode: TMode); overload;
begin
  eng := enZGLineInit_mode(mode);
  log := eng.GetLog;
  inp := eng.GetInp;
  wnd := eng.GetWnd;
  fsys := eng.GetFSys;
  tex1D := eng.GetTex1D;
  tex2D := eng.GetTex;
  tex3D := eng.GetTex3D;
  txc := eng.GetTXPak;
  txq := eng.GetTXQ;
  ogl := eng.GetOGL;
  mdl := eng.GetMdl;
  vbo := eng.GetVBO;
  fbo := eng.GetFBO;
  vfp := eng.GetVFP;
  pts := eng.GetPSys;
  occ := eng.GetOCC;
  cam := eng.GetCam;
  math3D := eng.GetMath;
  oal := eng.GetOAL;
end;

procedure InitENZGLINE;
begin
  eng := enZGLineInit;
  log := eng.GetLog;
  inp := eng.GetInp;
  wnd := eng.GetWnd;
  fsys := eng.GetFSys;
  tex1D := eng.GetTex1D;
  tex2D := eng.GetTex;
  tex3D := eng.GetTex3D;
  txc := eng.GetTXPak;
  txq := eng.GetTXQ;
  ogl := eng.GetOGL;
  mdl := eng.GetMdl;
  vbo := eng.GetVBO;
  fbo := eng.GetFBO;
  vfp := eng.GetVFP;
  pts := eng.GetPSys;
  occ := eng.GetOCC;
  cam := eng.GetCam;  
  math3D := eng.GetMath;
  oal := eng.GetOAL;
end;

initialization
  eng    := nil;
  log    := nil;
  wnd    := nil;
  fsys   := nil;
  inp    := nil;
  ogl    := nil;
  tex1D  := nil;
  tex2D  := nil;
  tex3D  := nil;
  txc    := nil;
  txq    := nil;
  mdl    := nil;
  vbo    := nil;
  fbo    := nil;
  vfp    := nil;
  pts    := nil;
  occ    := nil;
  cam    := nil;
  oal    := nil;
  math3D := nil;

finalization
  math3D := nil;
  oal    := nil;
  cam    := nil;
  occ    := nil;
  pts    := nil;  
  vfp    := nil;
  fbo    := nil;
  vbo    := nil;
  mdl    := nil;
  txq    := nil;
  txc    := nil;
  tex1D  := nil;
  tex2D  := nil;
  tex3D  := nil;
  ogl    := nil;
  inp    := nil;
  fsys   := nil;
  wnd    := nil;
  log    := nil;
  eng    := nil;

end.
